10    !*************************************************
20    !* 4294A + 16454A Permeability Measurement
30    !* Instrument BASIC Sample Program
40    !*************************************************
50    DIM R_data(1:801,1:2),X_data(1:801,1:2),Freq(1:801)
60    DIM Urr_data(1:801,1:2),Uri_data(1:801,1:2),Urm_data(1:801,1:2)
70    DIM Cole_data(1:801,1:2),Tan_d_data(1:801,1:2)
80    !
90    ASSIGN @Agt4294a TO 800
100   Scode=8
110   OUTPUT @Agt4294a;"DISA HIHB"
120   OUTPUT @Agt4294a;"HOLD"
130   !
140 Constants:   !
150   U0=1.257E-6
160   !########################################## Main
170 Disp_proc: !
180   CLEAR SCREEN
190   PRINT "4294A + 16454A Permeability Measurement Program"
200   PRINT ""
210   PRINT "[ ]    Perform the adapter setup (7mm)"
220   PRINT "[ ]    Perform fixture compensation"
230   PRINT "x: done, s: skip."
240   !
250 Adjustment: !
260   GOSUB Adapter_setup
270   GOSUB Fixt_compen
280 Meas:!
290   GOSUB Input_size
300   GOSUB Sweep
310   GOSUB Calc
320   GOTO Display
330   !
340   !########################################## Sub-routines
350 Adapter_setup: !
360   OUTPUT @Agt4294a;"E4TP APC7"
370   DISP "Perform the adapter setup?    0:Yes, 1:Skip";
380   INPUT "",Ans
390   IF Ans=1 THEN
400     PRINT TABXY(2,3);"s]   "
410     RETURN
420   END IF
430   F_adapt_setup=1
440   OUTPUT @Agt4294a;"PRES"
450   PRINT TABXY(5,3);"->"
460   OUTPUT @Agt4294a;"ESNB 256; *SRE 4"
470   !
480   OUTPUT @Agt4294a;"*CLS"
490   ON INTR Scode GOTO Phase_meas_end
500   ENABLE INTR Scode;2
510   DISP "Connect OPEN (0S) to the 7mm port and press 'Continue'."
520   PAUSE
530   DISP "Now measuring PHASE data..."
540   OUTPUT @Agt4294a;"ECALP"
550 Phase_meas_wait: GOTO Phase_meas_wait
560 Phase_meas_end: !
570   OUTPUT @Agt4294a;"*CLS"
580   ON INTR Scode GOTO Open_meas_end
590   ENABLE INTR Scode;2
600   DISP "Now measuring OPEN data..."
610   OUTPUT @Agt4294a;"ECALA"
620 Open_meas_wait: GOTO Open_meas_wait
630 Open_meas_end: !
640   OUTPUT @Agt4294a;"*CLS"
650   ON INTR Scode GOTO Short_meas_end
660   ENABLE INTR Scode;2
670   DISP "Connect SHORT (0-OHM) to the 7mm port and press 'Continue'."
680   PAUSE
690   DISP "Now measuring SHORT data..."
700   OUTPUT @Agt4294a;"ECALB"
710 Short_meas_wait: GOTO Short_meas_wait
720 Short_meas_end: !
730   OUTPUT @Agt4294a;"*CLS"
740   ON INTR Scode GOTO Load_meas_end
750   ENABLE INTR Scode;2
760   DISP "Connect LOAD (50-OHM) to the 7mm port and press 'Continue'."
770   PAUSE
780   DISP "Now measuring LOAD data..."
790   OUTPUT @Agt4294a;"ECALC"
800 Load_meas_wait: GOTO Load_meas_wait
810 Load_meas_end: !
820   DISP "Now storing setup data..."
830   OUTPUT @Agt4294a;"ECALDON"
840   DISP ""
850   PRINT TABXY(2,3);"x]   "
860   RETURN
870   !
880 Fixt_compen: !
890   DISP "Connect the 16454A to the 7mm port and press 'Continue'."
900   PAUSE
910   IF F_adapt_setup=0 THEN
920     DISP "Perform the fixture compensation?    0:Yes, 1:Skip";
930     INPUT "",Ans
940     IF Ans=1 THEN
950       PRINT TABXY(2,4);"s]   "
960       RETURN
970     END IF
980   END IF
990   PRINT TABXY(4,4);"->"
1000 Input_config:!
1010  DISP "Start frequency [Hz] = ?";
1020  INPUT "",Start
1030  DISP "Stop frequency [Hz] = ?";
1040  INPUT "",Stop
1050  DISP "Sweep type?   0:Linear, 1:Log";
1060  INPUT Ans
1070  IF Ans=1 THEN
1080    Swe_type$="LOG"
1090  ELSE
1100    Swe_type$="LIN"
1110  END IF
1120  DISP "OSC level [V] =?";
1130  INPUT "",Vosc
1140  DISP "Number of point?   [2-801]";
1150  INPUT Nop
1160  DISP "BW ?  [1-5]";
1170  INPUT Bw
1180  PRINT TABXY(1,10);"Start: ";Start;"[Hz]  Stop: ";Stop;"[Hz]";"  Nop: ";Nop
1190  PRINT TABXY(1,11);"Sweep Type: ";Swe_type$;"  OSC Level: ";Vosc;"[V]  BW: ";Bw;
1200  DISP "Measurement condition is OK?       0:OK, 1:NO";
1210  INPUT "",Ans
1220  IF Ans<>0 THEN Input_config
1230  !
1240  OUTPUT @Agt4294a;"CALP USER"
1250  OUTPUT @Agt4294a;"MEAS IRIM"
1260  OUTPUT @Agt4294a;"STAR ";Start
1270  OUTPUT @Agt4294a;"STOP ";Stop
1280  OUTPUT @Agt4294a;"SWPT ";Swe_type$
1290  OUTPUT @Agt4294a;"POIN ";Nop
1300  OUTPUT @Agt4294a;"BWFACT ";Bw
1310  OUTPUT @Agt4294a;"POWMOD VOLT;POWE ";Vosc
1320  DISP "Insert the MUT holder (without MUT) and press 'Continue'."
1330  PAUSE
1340  DISP "Now measuring SHORT data..."
1350  OUTPUT @Agt4294a;";COMB"
1360  OUTPUT @Agt4294a;"*OPC?"
1370  ENTER @Agt4294a;Opc
1380  DISP ""
1390  PRINT TABXY(2,4);"x]   "
1400  RETURN
1410  !
1420 Input_size: !
1430  DISP "Outer diameter of MUT [mm] = ?";
1440  INPUT "",Ans
1450  C=Ans/1000
1460  DISP "Inner diameter of MUT [mm] = ?";
1470  INPUT "",Ans
1480  B=Ans/1000
1490  DISP "Height of MUT [mm] = ?";
1500  INPUT "",Ans
1510  H=Ans/1000
1520  RETURN
1530  !
1540 Sweep: !
1550  DISP "Insert MUT (with holder) into fixture and press 'Continue'."
1560  PAUSE
1570  OUTPUT @Agt4294a;"DISA BASS"
1580  OUTPUT @Agt4294a;"MEAS IRIM"
1590  OUTPUT @Agt4294a;"HIDI OFF"
1600  OUTPUT @Agt4294a;"SING"
1610  DISP "Now measuring R-X..."
1620  OUTPUT @Agt4294a;"*OPC?"
1630  ENTER @Agt4294a;Opc
1640  DISP "Now getting data..."
1650  OUTPUT @Agt4294a;"TRAC A"
1660  OUTPUT @Agt4294a;"AUTO"
1670  OUTPUT @Agt4294a;"OUTPDTRC?"
1680  ENTER @Agt4294a USING "%,K";R_data(*)
1690  OUTPUT @Agt4294a;"TRAC B"
1700  OUTPUT @Agt4294a;"AUTO"
1710  OUTPUT @Agt4294a;"OUTPDTRC?"
1720  ENTER @Agt4294a USING "%,K";X_data(*)
1730  OUTPUT @Agt4294a;"OUTPSWPRM?"
1740  ENTER @Agt4294a USING "%,K";Freq(*)
1750  RETURN
1760  !
1770 Calc: !
1780  OUTPUT @Agt4294a;"POIN?"
1790  ENTER @Agt4294a;Nop
1800  FOR I=1 TO Nop
1810    Urr_data(I,1)=(X_data(I,1)/(Freq(I)*U0*H*LOG(C/B)))+1
1820    Urr_data(I,2)=0
1830    Uri_data(I,1)=R_data(I,1)/(Freq(I)*U0*H*LOG(C/B))
1840    Uri_data(I,2)=0
1850    Tan_d_data(I,1)=Uri_data(I,1)/ABS(Urr_data(I,1))
1860    Tan_d_data(I,2)=0
1870    Urm_data(I,1)=SQR(Urr_data(I,1)^2+Uri_data(I,1)^2)
1880    Urm_data(I,2)=0
1890    Cole_data(I,1)=Urr_data(I,1)
1900    Cole_data(I,2)=Uri_data(I,1)
1910  NEXT I
1920  RETURN
1930  !
1940 Display: !
1950  ON KEY 1 LABEL "ur' -          tan d",1 GOSUB Disp_ur_d
1960  ON KEY 2 LABEL "|ur| -         tan d",1 GOSUB Disp_um_d
1970  ON KEY 3 LABEL "ur' -           ur''",1 GOSUB Disp_ur_ui
1980  ON KEY 4 LABEL "Cole-cole       Plot",1 GOSUB Disp_cole
1990  ON KEY 7 LABEL "Quit",1 GOTO Quit
2000  ON KEY 8 LABEL "Re-measure",1 GOTO Re_meas
2010  OUTPUT @Agt4294a;"USKEY"
2020  BEEP
2030  DISP "Select softkey to display each parameter."
2040 Loop: GOTO Loop
2050  !
2060 Disp_ur_d: !
2070  DISP "Now loading data..."
2080  OUTPUT @Agt4294a;"MEAS IMD"
2090  OUTPUT @Agt4294a;"HIDI OFF;SPLD ON"
2100  OUTPUT @Agt4294a;"TRAC A"
2110  OUTPUT @Agt4294a;"INPUDTRC ";
2120  FOR I=1 TO Nop
2130    OUTPUT @Agt4294a;Urr_data(I,1),Urr_data(I,2);
2140  NEXT I
2150  OUTPUT @Agt4294a;""
2160  OUTPUT @Agt4294a;"AUTO"
2170  OUTPUT @Agt4294a;"TRAC B"
2180  FOR I=1 TO Nop
2190    OUTPUT @Agt4294a;"INPUDTRC ";
2200    OUTPUT @Agt4294a;Tan_d_data(I,1),Tan_d_data(I,2);
2210  NEXT I
2220  OUTPUT @Agt4294a;""
2230  OUTPUT @Agt4294a;"AUTO"
2240  OUTPUT @Agt4294a;"TRAC A"
2250  BEEP
2260  DISP "A: ur'  B: tan d "
2270  RETURN
2280  !
2290 Disp_um_d: !
2300  DISP "Now loading data..."
2310  OUTPUT @Agt4294a;"MEAS IMD"
2320  OUTPUT @Agt4294a;"HIDI OFF;SPLD ON"
2330  OUTPUT @Agt4294a;"TRAC A"
2340  OUTPUT @Agt4294a;"INPUDTRC ";
2350  FOR I=1 TO Nop
2360    OUTPUT @Agt4294a;Urm_data(I,1),Urm_data(I,2);
2370  NEXT I
2380  OUTPUT @Agt4294a;""
2390  OUTPUT @Agt4294a;"AUTO"
2400  OUTPUT @Agt4294a;"TRAC B"
2410  FOR I=1 TO Nop
2420    OUTPUT @Agt4294a;"INPUDTRC ";
2430    OUTPUT @Agt4294a;Tan_d_data(I,1),Tan_d_data(I,2);
2440  NEXT I
2450  OUTPUT @Agt4294a;""
2460  OUTPUT @Agt4294a;"AUTO"
2470  OUTPUT @Agt4294a;"TRAC A"
2480  BEEP
2490  DISP "A: |ur|  B: tan d "
2500  RETURN
2510  !
2520 Disp_ur_ui: !
2530  DISP "Now loading data..."
2540  OUTPUT @Agt4294a;"MEAS LSR"
2550  OUTPUT @Agt4294a;"HIDI OFF;SPLD ON"
2560  OUTPUT @Agt4294a;"TRAC A"
2570  OUTPUT @Agt4294a;"INPUDTRC ";
2580  FOR I=1 TO Nop
2590    OUTPUT @Agt4294a;Urr_data(I,1),Urr_data(I,2);
2600  NEXT I
2610  OUTPUT @Agt4294a;""
2620  OUTPUT @Agt4294a;"AUTO"
2630  OUTPUT @Agt4294a;"TRAC B"
2640  FOR I=1 TO Nop
2650    OUTPUT @Agt4294a;"INPUDTRC ";
2660    OUTPUT @Agt4294a;Uri_data(I,1),Uri_data(I,2);
2670  NEXT I
2680  OUTPUT @Agt4294a;""
2690  OUTPUT @Agt4294a;"AUTO"
2700  OUTPUT @Agt4294a;"TRAC A"
2710  BEEP
2720  DISP "A: ur'  B: ur''  "
2730  RETURN
2740  !
2750 Disp_cole: !
2760  DISP "Now loading data..."
2770  OUTPUT @Agt4294a;"MEAS COMP"
2780  OUTPUT @Agt4294a;"HIDI ON;SPLD OFF"
2790  OUTPUT @Agt4294a;"TRAC A"
2800  OUTPUT @Agt4294a;"INPUDTRC ";
2810  FOR I=1 TO Nop
2820    OUTPUT @Agt4294a;Cole_data(I,1),Cole_data(I,2);
2830  NEXT I
2840  OUTPUT @Agt4294a;""
2850  OUTPUT @Agt4294a;"AUTO"
2860  BEEP
2870  DISP "Cole-cole Plot"
2880  RETURN
2890  !
2900 Re_meas: !
2910  DISP "Measure once more?        0:Yes, 1:Cancel";
2920  INPUT "",Ans
2930  SELECT Ans
2940  CASE 0
2950    GOTO Meas
2960  CASE 1
2970    GOTO Display
2980  CASE ELSE
2990    GOTO Re_meas
3000  END SELECT
3010  !
3020 Quit: !
3030  DISP "Really quit the program?     0:Yes, 1:Cancel";
3040  INPUT "",Ans
3050  SELECT Ans
3060  CASE 0
3070    DISP "Bye."
3080  CASE 1
3090    GOTO Display
3100  CASE ELSE
3110    GOTO Quit
3120  END SELECT
3130  END
5000   !*************************************************
5010   !* DESCRIPTION:  Agilent 4294A Sample Program
5020   !*
5030   !* AUTHOR:       Agilent Technologies Japan, Ltd.
5040   !* CREATED:      3/21/2000
5050   !* PROGRAM NAME: permeabi.bas
5060   !* REVISION:     A.01.00
5070   !*
5080   !*    Copyright (c) 2000 Agilent Technologies,
5090   !*             All rights reserved.
5100   !*
5110   !*
5120   !*  Customer shall have the personal, non-
5130   !* transferable rights to use, copy or modify
5140   !* this SAMPLE PROGRAM for Customer's internal
5150   !* operations. Customer shall use the SAMPLE
5160   !* PROGRAM solely and exclusively for its own
5170   !* purpose and shall not license, lease, market
5180   !* or distribute the SAMPLE PROGRAM or
5190   !* modification or any part thereof.
5200   !*
5210   !*  Agilent Technologies shall not be liable for
5220   !* the quality, performance or behavior of the
5230   !* SAMPLE PROGRAM. Agilent Technologies especially
5240   !* disclaims that the operation of the SAMPLE
5250   !* PROGRAM shall be uninterrupted or error free.
5260   !* This SAMPLE PROGRAM is provided AS IS.
5270   !*
5280   !*  AGILENT TECHNOLOGIES DISCLAIMS THE IMPLIED
5290   !* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
5300   !* A PARTICULAR PURPOSE.
5310   !*
5320   !*  Agilent Technologies shall not be liable for
5330   !* any infringement of any patent, trademark,
5340   !* copyright or other proprietary rights by the
5350   !* SAMPLE PROGRAM or its use. Agilent Technologies
5360   !* does not warrant that the SAMPLE PROGRAM is
5370   !* free from infringements or such rights of third
5380   !* parties. However, Agilent Technologies will not
5390   !* knowingly infringe or deliver a software that
5400   !* infringes the patent, trademark, copyright or
5410   !* other proprietary right of a third party.
5420   !*
5430   !*************************************************
