10    !**************************************************************
20    !* 4294A + 16451B Permittivity Measurement (Contact Method)
30    !* Instrument BASIC Sample Program
40    !**************************************************************
50    DIM Cp_data(1:801,1:2),D_data(1:801,1:2),Err_data(1:801,1:2)
60    DIM Eri_data(1:801,1:2),Erm_data(1:801,1:2),Cole_data(1:801,1:2)
70    !
80    ASSIGN @Agt4294a TO 800
90    OUTPUT @Agt4294a;"DISA HIHB"
100   OUTPUT @Agt4294a;"HOLD"
110   !
120 Constants:   !
130   E0=8.854E-12
140   Adj_center=100000.
150   Adj_up_limit_a=1.E-9
160   Adj_low_limit_a=7.E-10
170   Adj_up_limit_b=2.E-11
180   Adj_low_limit_b=1.2E-11
190   Load_center=100000.
200   Load_ave=4
210   Load_bw=5
220   Load_up_limit_a=5.05E-11  ! [pF]
230   Load_lo_limit_a=4.95E-11
240   Load_up_limit_b=5.05E-12
250   Load_lo_limit_b=4.95E-12
260   Load_up_limit_c=1.55E-12
270   Load_lo_limit_c=1.45E-12
280   Load_up_limit_d=1.55E-12
290   Load_lo_limit_d=1.45E-12
300   Open_r=1.E+11             ! [ohm]
310   Open_l=0
320   Short_r=0
330   Short_l=0
340   Load_g=0
350   Bw=3
360   D_elec_a=.038             ! [m]
370   D_elec_b=.005
380   !
390   !########################################## Main
400 Disp_proc:!
410   CLEAR SCREEN
420   PRINT "4294A + 16451B Permittivity Measurement Program"
430   PRINT "  (Contact Method Measurment)"
440   PRINT ""
450   PRINT "[ ]    Select the main electrode of 16451B"
460   PRINT "[ ]    Perform the adapter setup (1m cable)"
470   PRINT "[ ]    Adjust the electrodes (Parallelizing)"
480   PRINT "[ ]    Perform fixture compensation"
490   PRINT "x: done, s: skip, n: not required."
500   !
510 Adjustment:   !
520   GOSUB Select_elec
530   GOSUB Adapter_setup
540   GOSUB Adjust
550   GOSUB Compen
560 Meas:  !
570   GOSUB Input_t
580   GOSUB Input_d
590   GOSUB Sweep
600   GOSUB Calc
610   GOTO Display
620   !
630   !########################################## Sub-routines
640 Select_elec:!
650   PRINT TABXY(5,4);"->"
660   DISP "Which electrode of 16451B is used?  0:A, 1:B, 2:C, 3:D";
670   INPUT "",Ans
680   SELECT Ans
690   CASE 0
700     Elec$="A"
710     Adj_up_limit=Adj_up_limit_a
720     Adj_low_limit=Adj_low_limit_a
730     Load_up_limit=Load_up_limit_a
740     Load_low_limit=Load_lo_limit_a
750   CASE 1
760     Elec$="B"
770     Adj_up_limit=Adj_up_limit_b
780     Adj_low_limit=Adj_low_limit_b
790     Load_up_limit=Load_up_limit_b
800     Load_low_limit=Load_lo_limit_b
810   CASE 2
820     Elec$="C"
830     Load_up_limit=Load_up_limit_c
840     Load_low_limit=Load_lo_limit_c
850   CASE 3
860     Elec$="D"
870     Load_up_limit=Load_up_limit_d
880     Load_low_limit=Load_lo_limit_d
890   CASE ELSE 
900     GOTO Select_elec
910   END SELECT 
920   DISP "The electrode ";Elec$;" is selected. OK?   0:OK, 1:No";
930   INPUT "",Ans
940   IF Ans<>0 THEN Select_elec
950   PRINT TABXY(2,4);"x]   "
960   RETURN
970   !
980 Adapter_setup:!
990   DISP "Perform the adapter setup?    0:Yes, 1:Skip";
1000  INPUT "",Ans
1010  IF Ans=1 THEN
1020    PRINT TABXY(2,5);"s]   "
1030    RETURN
1040  END IF 
1050  F_adapt_setup=1
1060  OUTPUT @Agt4294a;"PRES"
1070  PRINT TABXY(5,5);"->"
1080  DISP "Set the 16451B OPEN condition and press 'Continue'."
1090  PAUSE
1100  DISP "Wait until the setup is finished."
1110  OUTPUT @Agt4294a;"E4TP M1;ECALP"
1120  OUTPUT @Agt4294a;"*OPC?"
1130  ENTER @Agt4294a;Opc
1140  OUTPUT @Agt4294a;"ECALDON"
1150  DISP ""
1160  PRINT TABXY(2,5);"x]   "
1170  RETURN
1180  !
1190 Adjust:!
1200  IF Elec$="C" OR Elec$="D" THEN
1210    PRINT TABXY(2,6);"n]   "
1220    RETURN
1230  END IF 
1240  IF F_adapt_setup=0 THEN
1250    DISP "Perform the electrode adjustment?    0:Yes, 1:Skip";
1260    INPUT "",Ans
1270    IF Ans=1 THEN
1280      PRINT TABXY(2,6);"s]   "
1290      RETURN
1300    END IF 
1310  END IF 
1320  F_adjust=1
1330  PRINT TABXY(5,6);"->"
1340  OUTPUT @Agt4294a;"SWPT LIN"
1350  OUTPUT @Agt4294a;"CENT ";Adj_center
1360  OUTPUT @Agt4294a;"SPAN 0"
1370  OUTPUT @Agt4294a;"POIN 2"
1380  OUTPUT @Agt4294a;"CALP USER"
1390  OUTPUT @Agt4294a;"MEAS CPD;TRAC A"
1400  OUTPUT @Agt4294a;"HIDI ON"
1410  OUTPUT @Agt4294a;"EDITLIML"
1420  OUTPUT @Agt4294a;"LIMCLEL ;LIMSADD"
1430  OUTPUT @Agt4294a;"LIMSTAR ";Adj_center
1440  OUTPUT @Agt4294a;"LIMSTOP ";Adj_center
1450  OUTPUT @Agt4294a;"LIMLSTAR ";Adj_low_limit
1460  OUTPUT @Agt4294a;"LIMUSTAR ";Adj_up_limit
1470  OUTPUT @Agt4294a;"LIMLSTOP ";Adj_low_limit
1480  OUTPUT @Agt4294a;"LIMUSTOP ";Adj_up_limit
1490  OUTPUT @Agt4294a;"LIMSDON;;LIMEDONE"
1500  OUTPUT @Agt4294a;"TOPV ";1.5*Adj_up_limit-.5*Adj_low_limit
1510  OUTPUT @Agt4294a;"BOTV ";1.5*Adj_low_limit-.5*Adj_up_limit
1520  !
1530  OUTPUT @Agt4294a;"LIMITEST OFF"
1540  DISP "Set the micrometer of 16451B at 10um and press 'Continue'."
1550  PAUSE
1560  OUTPUT @Agt4294a;"LIMITEST ON"
1570  OUTPUT @Agt4294a;"CONT"
1580  OUTPUT @Agt4294a;"MKR ON"
1590  DISP "Adjust the electrode until PASS is displayed"
1600  PAUSE
1610  OUTPUT @Agt4294a;"HOLD"
1620  OUTPUT @Agt4294a;"OUTPFAIP?"
1630  ENTER @Agt4294a;F_nop
1640  IF F_nop<>0 THEN Adj
1650  OUTPUT @Agt4294a;"LIMITEST OFF"
1660  PRINT TABXY(2,6);"x]   "
1670  RETURN
1680  !
1690 Compen:!
1700  IF F_adjust=0 THEN
1710    DISP "Perform the fixture compensation?    0:Yes, 1:Skip";
1720    INPUT "",Ans
1730    IF Ans=1 THEN
1740      PRINT TABXY(2,7);"s]   "
1750      RETURN
1760    END IF 
1770  END IF 
1780  PRINT TABXY(4,7);"->"
1790 Input_config:!
1800  DISP "Start frequency [Hz] = ?";
1810  INPUT "",Start
1820  DISP "Stop frequency [Hz] = ?";
1830  INPUT "",Stop
1840  DISP "Sweep type?   0:Linear, 1:Log";
1850  INPUT Ans
1860  IF Ans=1 THEN
1870    Swe_type$="LOG"
1880  ELSE 
1890    Swe_type$="LIN"
1900  END IF 
1910  DISP "OSC level [V] =?";
1920  INPUT "",Vosc
1930  DISP "Number of point?   [2-801]";
1940  INPUT Nop
1950  PRINT TABXY(1,10);"Start: ";Start;"[Hz]  Stop: ";Stop;"[Hz]";"  Nop: ";Nop
1960  PRINT TABXY(1,11);"Sweep Type: ";Swe_type$;"  OSC Level: ";Vosc;"[V]";
1970  DISP "Measurement condition is OK?       0:OK, 1:NO";
1980  INPUT "",Ans
1990  IF Ans<>0 THEN Input_config
2000  !
2010  OUTPUT @Agt4294a;"CALP USER"
2020  OUTPUT @Agt4294a;"MEAS CPD;TRAC A"
2030  OUTPUT @Agt4294a;"SWPT LIN"
2040  OUTPUT @Agt4294a;"CENT ";Load_center
2050  OUTPUT @Agt4294a;"SPAN 0"
2060  OUTPUT @Agt4294a;"POIN ";2
2070  OUTPUT @Agt4294a;"BWFACT ";Load_bw
2080  OUTPUT @Agt4294a;"PAVER ON;PAVERFACT ";Load_ave
2090  OUTPUT @Agt4294a;"LIMITEST ON;EDITLIML"
2100  OUTPUT @Agt4294a;"LIMCLEL ;LIMSADD"
2110  OUTPUT @Agt4294a;"LIMSTAR ";Load_center
2120  OUTPUT @Agt4294a;"LIMSTOP ";Load_center
2130  OUTPUT @Agt4294a;"LIMLSTAR ";Load_low_limit
2140  OUTPUT @Agt4294a;"LIMUSTAR ";Load_up_limit
2150  OUTPUT @Agt4294a;"LIMLSTOP ";Load_low_limit
2160  OUTPUT @Agt4294a;"LIMUSTOP ";Load_up_limit
2170  OUTPUT @Agt4294a;"LIMSDON;LIMEDONE"
2180  OUTPUT @Agt4294a;"TOPV ";1.5*Load_up_limit-.5*Load_low_limit
2190  OUTPUT @Agt4294a;"BOTV ";1.5*Load_low_limit-.5*Load_up_limit
2200  OUTPUT @Agt4294a;"HIDI ON"
2210  !
2220 Load_adj:!
2230  OUTPUT @Agt4294a;"CONT"
2240  OUTPUT @Agt4294a;"MKR ON"
2250  DISP "Turn the micrometer's knob until PASS is displayed."
2260  PAUSE
2270  OUTPUT @Agt4294a;"HOLD"
2280  OUTPUT @Agt4294a;"OUTPFAIP?"
2290  ENTER @Agt4294a;F_nop
2300  IF F_nop<>0 THEN Load_adj
2310  DISP ""
2320  OUTPUT @Agt4294a;"LIMITEST OFF"
2330  OUTPUT @Agt4294a;"OUTPDTRCP? 1"
2340  ENTER @Agt4294a;Load_c,Dummy
2350  !
2360  OUTPUT @Agt4294a;"STAR ";Start
2370  OUTPUT @Agt4294a;"STOP ";Stop
2380  OUTPUT @Agt4294a;"SWPT ";Swe_type$
2390  OUTPUT @Agt4294a;"POIN ";Nop
2400  OUTPUT @Agt4294a;"BWFACT ";Bw
2410  OUTPUT @Agt4294a;"POWMOD VOLT;POWE ";Vosc
2420  OUTPUT @Agt4294a;"DCOMOPENG ";Load_g
2430  OUTPUT @Agt4294a;"DCOMOPENC ";Load_c/1.E-15
2440  OUTPUT @Agt4294a;"DCOMSHORR ";Short_r
2450  OUTPUT @Agt4294a;"DCOMSHORL ";Short_l
2460  OUTPUT @Agt4294a;"DCOMLOADR ";Open_r
2470  OUTPUT @Agt4294a;"DCOMLOADL ";Open_l
2480  !
2490  OUTPUT @Agt4294a;"COMA"
2500  DISP "Now measuring LOAD..."
2510  OUTPUT @Agt4294a;"*OPC?"
2520  ENTER @Agt4294a;Opc
2530  DISP "Set 16451B OPEN condition and press 'Continue'."
2540  PAUSE
2550  OUTPUT @Agt4294a;"COMC"
2560  DISP "Now measuring OPEN..."
2570  OUTPUT @Agt4294a;"*OPC?"
2580  ENTER @Agt4294a;Opc
2590  DISP "Set 16451B SHORT condition and press 'Continue'."
2600  PAUSE
2610  DISP "Now measuring SHORT..."
2620  OUTPUT @Agt4294a;"COMB"
2630  OUTPUT @Agt4294a;"*OPC?"
2640  ENTER @Agt4294a;Opc
2650  DISP ""
2660  PRINT TABXY(2,7);"x]   "
2670  RETURN
2680  !
2690 Input_t:!
2700  DISP "Thickness of MUT [mm] = ?";
2710  INPUT "",Ans
2720  T_dut=Ans/1000
2730  RETURN
2740  !
2750 Input_d:!
2760  SELECT Elec$
2770  CASE "A"
2780    D_elec=D_elec_a
2790    RETURN
2800  CASE "B"
2810    D_elec=D_elec_b
2820    RETURN
2830  CASE ELSE 
2840    DISP "Diameter of electrode [mm] = ?";
2850    INPUT "",D_elec
2860    D_elec=D_elec*.001
2870    RETURN
2880  END SELECT 
2890  RETURN
2900  !
2910 Sweep: !
2920  DISP "Set MUT between the electrodes and press 'Continue'."
2930  PAUSE
2940  OUTPUT @Agt4294a;"DISA BASS"
2950  OUTPUT @Agt4294a;"MEAS CPD"
2960  OUTPUT @Agt4294a;"HIDI OFF"
2970  OUTPUT @Agt4294a;"SING"
2980  DISP "Now measuring Cp-D..."
2990  OUTPUT @Agt4294a;"*OPC?"
3000  ENTER @Agt4294a;Opc
3010  DISP "Now getting data..."
3020  OUTPUT @Agt4294a;"TRAC A"
3030  OUTPUT @Agt4294a;"AUTO"
3040  OUTPUT @Agt4294a;"OUTPDTRC?"
3050  ENTER @Agt4294a USING "%,K";Cp_data(*)
3060  OUTPUT @Agt4294a;"TRAC B"
3070  OUTPUT @Agt4294a;"AUTO"
3080  OUTPUT @Agt4294a;"OUTPDTRC?"
3090  ENTER @Agt4294a USING "%,K";D_data(*)
3100  RETURN
3110  !
3120 Calc: !
3130  FOR I=1 TO Nop
3140    Err_data(I,1)=(T_dut*Cp_data(I,1))/(PI*E0*(D_elec/2)^2)
3150    Err_data(I,2)=0
3160    Eri_data(I,1)=Err_data(I,1)*D_data(I,1)
3170    Eri_data(I,2)=0
3180    Erm_data(I,1)=SQR(Err_data(I,1)^2+Eri_data(I,1)^2)
3190    Erm_data(I,2)=0
3200    Cole_data(I,1)=Err_data(I,1)
3210    Cole_data(I,2)=Eri_data(I,1)
3220  NEXT I
3230  RETURN
3240  !
3250 Display:!
3260  ON KEY 1 LABEL "er' -          tan d",1 GOSUB Disp_er_d
3270  ON KEY 2 LABEL "|er| -         tan d",1 GOSUB Disp_em_d
3280  ON KEY 3 LABEL "er' -           er''",1 GOSUB Disp_er_ei
3290  ON KEY 4 LABEL "Cole-cole       Plot",1 GOSUB Disp_cole
3300  ON KEY 7 LABEL "Quit",1 GOTO Quit
3310  ON KEY 8 LABEL "Re-measure",1 GOTO Re_meas
3320  OUTPUT @Agt4294a;"USKEY"
3330  BEEP
3340  DISP "Select softkey to display each parameter."
3350 Loop:GOTO Loop
3360  !
3370 Disp_er_d:        !
3380  DISP "Now loading data..."
3390  OUTPUT @Agt4294a;"MEAS CPD"
3400  OUTPUT @Agt4294a;"HIDI OFF;SPLD ON"
3410  OUTPUT @Agt4294a;"TRAC A"
3420  OUTPUT @Agt4294a;"INPUDTRC ";
3430  FOR I=1 TO Nop
3440    OUTPUT @Agt4294a;Err_data(I,1),Err_data(I,2);
3450  NEXT I
3460  OUTPUT @Agt4294a;""
3470  OUTPUT @Agt4294a;"AUTO"
3480  OUTPUT @Agt4294a;"TRAC B"
3490  FOR I=1 TO Nop
3500    OUTPUT @Agt4294a;"INPUDTRC ";
3510    OUTPUT @Agt4294a;D_data(I,1),D_data(I,2);
3520  NEXT I
3530  OUTPUT @Agt4294a;""
3540  OUTPUT @Agt4294a;"AUTO"
3550  OUTPUT @Agt4294a;"TRAC A"
3560  BEEP
3570  DISP "A: er'  B: tan d  /  Thickness: ";T_dut*1000;"[mm]"
3580  RETURN
3590  !
3600 Disp_em_d: !
3610  DISP "Now loading data..."
3620  OUTPUT @Agt4294a;"MEAS CPD"
3630  OUTPUT @Agt4294a;"HIDI OFF;SPLD ON"
3640  OUTPUT @Agt4294a;"TRAC A"
3650  OUTPUT @Agt4294a;"INPUDTRC ";
3660  FOR I=1 TO Nop
3670    OUTPUT @Agt4294a;Erm_data(I,1),Erm_data(I,2);
3680  NEXT I
3690  OUTPUT @Agt4294a;""
3700  OUTPUT @Agt4294a;"AUTO"
3710  OUTPUT @Agt4294a;"TRAC B"
3720  FOR I=1 TO Nop
3730    OUTPUT @Agt4294a;"INPUDTRC ";
3740    OUTPUT @Agt4294a;D_data(I,1),D_data(I,2);
3750  NEXT I
3760  OUTPUT @Agt4294a;""
3770  OUTPUT @Agt4294a;"AUTO"
3780  OUTPUT @Agt4294a;"TRAC A"
3790  BEEP
3800  DISP "A: |er|  B: tan d  /  Thickness: ";T_dut*1000;"[mm]"
3810  RETURN
3820  !
3830 Disp_er_ei: !
3840  DISP "Now loading data..."
3850  OUTPUT @Agt4294a;"MEAS CPD"
3860  OUTPUT @Agt4294a;"HIDI OFF;SPLD ON"
3870  OUTPUT @Agt4294a;"TRAC A"
3880  OUTPUT @Agt4294a;"INPUDTRC ";
3890  FOR I=1 TO Nop
3900    OUTPUT @Agt4294a;Err_data(I,1),Err_data(I,2);
3910  NEXT I
3920  OUTPUT @Agt4294a;""
3930  OUTPUT @Agt4294a;"AUTO"
3940  OUTPUT @Agt4294a;"TRAC B"
3950  FOR I=1 TO Nop
3960    OUTPUT @Agt4294a;"INPUDTRC ";
3970    OUTPUT @Agt4294a;Eri_data(I,1),Eri_data(I,2);
3980  NEXT I
3990  OUTPUT @Agt4294a;""
4000  OUTPUT @Agt4294a;"AUTO"
4010  OUTPUT @Agt4294a;"TRAC A"
4020  BEEP
4030  DISP "A: er'  B: er''  /  Thickness: ";T_dut*1000;"[mm]"
4040  RETURN
4050  !
4060 Disp_cole: !
4070  DISP "Now loading data..."
4080  OUTPUT @Agt4294a;"MEAS COMP"
4090  OUTPUT @Agt4294a;"HIDI ON;SPLD OFF"
4100  OUTPUT @Agt4294a;"TRAC A"
4110  OUTPUT @Agt4294a;"INPUDTRC ";
4120  FOR I=1 TO Nop
4130    OUTPUT @Agt4294a;Cole_data(I,1),Cole_data(I,2);
4140  NEXT I
4150  OUTPUT @Agt4294a;""
4160  OUTPUT @Agt4294a;"AUTO"
4170  BEEP
4180  DISP "Cole-cole Plot     Thickness: ";T_dut*1000;"[mm]"
4190  RETURN
4200  !
4210 Re_meas: !
4220  DISP "Measure once more?        0:Yes, 1:Cancel";
4230  INPUT "",Ans
4240  SELECT Ans
4250  CASE 0
4260    GOTO Meas
4270  CASE 1
4280    GOTO Display
4290  CASE ELSE 
4300    GOTO Re_meas
4310  END SELECT 
4320  !
4330 Quit:  !
4340  DISP "Really quit the program?     0:Yes, 1:Cancel";
4350  INPUT "",Ans
4360  SELECT Ans
4370  CASE 0
4380    DISP "Bye."
4390  CASE 1
4400    GOTO Display
4410  CASE ELSE 
4420    GOTO Quit
4430  END SELECT 
4440  END
5000   !*************************************************
5010   !* DESCRIPTION:  Agilent 4294A Sample Program
5020   !*
5030   !* AUTHOR:       Agilent Technologies Japan, Ltd.
5040   !* CREATED:      3/21/2000
5050   !* PROGRAM NAME: permi_c.bas
5060   !* REVISION:     A.01.00
5070   !*
5080   !*    Copyright (c) 2000 Agilent Technologies,
5090   !*             All rights reserved.
5100   !*
5110   !*
5120   !*  Customer shall have the personal, non-
5130   !* transferable rights to use, copy or modify
5140   !* this SAMPLE PROGRAM for Customer's internal
5150   !* operations. Customer shall use the SAMPLE
5160   !* PROGRAM solely and exclusively for its own
5170   !* purpose and shall not license, lease, market
5180   !* or distribute the SAMPLE PROGRAM or
5190   !* modification or any part thereof.
5200   !*
5210   !*  Agilent Technologies shall not be liable for
5220   !* the quality, performance or behavior of the
5230   !* SAMPLE PROGRAM. Agilent Technologies especially
5240   !* disclaims that the operation of the SAMPLE
5250   !* PROGRAM shall be uninterrupted or error free.
5260   !* This SAMPLE PROGRAM is provided AS IS.
5270   !*
5280   !*  AGILENT TECHNOLOGIES DISCLAIMS THE IMPLIED
5290   !* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
5300   !* A PARTICULAR PURPOSE.
5310   !*
5320   !*  Agilent Technologies shall not be liable for
5330   !* any infringement of any patent, trademark,
5340   !* copyright or other proprietary rights by the
5350   !* SAMPLE PROGRAM or its use. Agilent Technologies
5360   !* does not warrant that the SAMPLE PROGRAM is
5370   !* free from infringements or such rights of third
5380   !* parties. However, Agilent Technologies will not
5390   !* knowingly infringe or deliver a software that
5400   !* infringes the patent, trademark, copyright or
5410   !* other proprietary right of a third party.
5420   !*
5430   !*************************************************
