10     DIM Input_val$[9],Buff$[9],Adapter$[9]
20     REAL Open_g,Open_c,Short_r,Short_l,Load_r,Load_l
30     INTEGER Scode,Err_no
40     CLEAR SCREEN
50     IF SYSTEM$("SYSTEM ID")="HP4294A" THEN 
60       ASSIGN @Hp4294a TO 800
70       Scode=8
80     ELSE
90       ASSIGN @Hp4294a TO 717
100      Scode=7
110    END IF
120    Cal_point$="USER"
130    !
140    ! Initial Setting
150    !
160    OUTPUT @Hp4294a;"PRES"
170    OUTPUT @Hp4294a;"*OPC?"
180    ENTER @Hp4294a;Buff$
190    OUTPUT @Hp4294a;"CALP ";Cal_point$
200    !
210    ! Entry Standard Value
220    !
230    CALL Inp_data("Open(G)",Open_g)
240    CALL Inp_data("Open(C)",Open_c)
250    CALL Inp_data("Short(R)",Short_r)
260    CALL Inp_data("Short(L)",Short_l)
270    CALL Inp_data("Load(R)",Load_r)
280    CALL Inp_data("Load(L)",Load_l)
290    OUTPUT @Hp4294a;"DCALOPENG ";Open_g
300    OUTPUT @Hp4294a;"DCALOPENC ";Open_c/1.E-15
310    OUTPUT @Hp4294a;"DCALSHORR ";Short_r
320    OUTPUT @Hp4294a;"DCALSHORL ";Short_l
330    OUTPUT @Hp4294a;"DCALLOADR ";Load_r
340    OUTPUT @Hp4294a;"DCALLOADL ";Load_l
350    !
360    ! Data Measurement
370    !
380    OUTPUT @Hp4294a;"ESNB 256"
390    OUTPUT @Hp4294a;"*SRE 4"
400    !
410    Result=FNUser_cal(@Hp4294a,Scode,"Open")
420    IF Result<>0 THEN Prog_end
430    !
440    Result=FNUser_cal(@Hp4294a,Scode,"Short")
450    IF Result<>0 THEN Prog_end
460    !
470    Result=FNUser_cal(@Hp4294a,Scode,"Load")
480    IF Result<>0 THEN Prog_end
490    !
500    OUTPUT @Hp4294a;"CALDON"
510    OUTPUT @Hp4294a;"*OPC?"
520    ENTER @Hp4294a;Buff$
530    PRINT "All Data Measurement Complete"
540 Prog_end:  END
550    !
560    ! User Calibration Data Measurement Function
570    !
580  DEF FNUser_cal(@Hp4294a,INTEGER Scode,Standard$)
590    DIM Inp_char$[9],Err_mes$[50]
600    INTEGER Err_no
610    OUTPUT @Hp4294a;"*CLS"
620    PRINT "Set "&Standard$&"-Connection"
630    INPUT "OK? [Y/N]",Inp_char$
640    IF UPC$(Inp_char$)="Y" THEN 
650      ON INTR Scode GOTO Meas_end
660      ENABLE INTR Scode;2
670      SELECT Standard$
680        CASE "Open"
690          OUTPUT @Hp4294a;"CALA"
700        CASE "Short"
710          OUTPUT @Hp4294a;"CALB"
720        CASE "Load"
730          OUTPUT @Hp4294a;"CALC"
740      END SELECT
750      PRINT "Now measuring..."
760 Meas_wait:  GOTO Meas_wait
770 Meas_end:  !
780      OUTPUT @Hp4294a;"OUTPERRO?"
790      ENTER @Hp4294a;Err_no,Err_mes$
800      IF Err_no=0 THEN 
810        PRINT Standard$&" Data Measurement Complete"
820        RETURN 0
830      ELSE
840        PRINT "Error: "&Err_mes$
850        PRINT "Program Interruption"
860        OUTPUT @Hp4294a;"CALQUI"
870        RETURN -1
880      END IF
890    ELSE
900      PRINT "Program Interruption"
910      OUTPUT @Hp4294a;"CALQUI"
920      RETURN -1
930    END IF
940  FNEND
950    !
960    ! Data Input Function
970    !
980  SUB Inp_data(Mes$,Inp_val)
990    DIM Inp_char$[30]
1000   ON ERROR GOTO Inp_start
1010 Inp_start:!
1020   PRINT "Input "&Mes$
1030   INPUT "Value?",Inp_char$
1040   Inp_val=VAL(UPC$(Inp_char$))
1050   PRINT "Input value: ";Inp_val
1060   INPUT "OK? [Y/N]",Inp_char$
1070   IF UPC$(Inp_char$)<>"Y" THEN Inp_start
1080   OFF ERROR 
1090 SUBEND
5000   !*************************************************
5010   !* DESCRIPTION:  Agilent 4294A Sample Program
5020   !*
5030   !* AUTHOR:       Agilent Technologies Japan, Ltd.
5040   !* CREATED:      4/26/1999
5050   !* PROGRAM NAME: user_cal.bas
5060   !* REVISION:     A.01.00
5070   !*
5080   !*    Copyright (c) 1999 Agilent Technologies,
5090   !*             All rights reserved.
5100   !*
5110   !*
5120   !*  Customer shall have the personal, non-
5130   !* transferable rights to use, copy or modify
5140   !* this SAMPLE PROGRAM for Customer's internal
5150   !* operations. Customer shall use the SAMPLE
5160   !* PROGRAM solely and exclusively for its own
5170   !* purpose and shall not license, lease, market
5180   !* or distribute the SAMPLE PROGRAM or
5190   !* modification or any part thereof.
5200   !*
5210   !*  Agilent Technologies shall not be liable for
5220   !* the quality, performance or behavior of the
5230   !* SAMPLE PROGRAM. Agilent Technologies especially
5240   !* disclaims that the operation of the SAMPLE
5250   !* PROGRAM shall be uninterrupted or error free.
5260   !* This SAMPLE PROGRAM is provided AS IS.
5270   !*
5280   !*  AGILENT TECHNOLOGIES DISCLAIMS THE IMPLIED
5290   !* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
5300   !* A PARTICULAR PURPOSE.
5310   !*
5320   !*  Agilent Technologies shall not be liable for
5330   !* any infringement of any patent, trademark,
5340   !* copyright or other proprietary rights by the
5350   !* SAMPLE PROGRAM or its use. Agilent Technologies
5360   !* does not warrant that the SAMPLE PROGRAM is
5370   !* free from infringements or such rights of third
5380   !* parties. However, Agilent Technologies will not
5390   !* knowingly infringe or deliver a software that
5400   !* infringes the patent, trademark, copyright or
5410   !* other proprietary right of a third party.
5420   !*
5430   !*************************************************
